1. Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.數據結構

You may assume that each input would have exactly one solution, and you may not use the same element twice.app

Example:this

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

Boring brushing leetcode.
Found that the subject is a company interview topic.spa

This problem mainly use unordered_map .code

unordered_map allow two or more apper in data.but is  not ordered.blog

this is  my solutation:內存

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        unordered_map<int, int> mp;
        vector<int> v;
        for (int i = 0; i < nums.size(); ++i ){
            int  x = target - nums[i];
            if (mp.count(x) > 0) {
                v.push_back((mp.find(x))->second);
                v.push_back(i);
                break;
            }
            mp.insert({nums[i],i});
        }
        return v;
    }
};

 

o(n)ci

STL中,map對應的數據結構是紅黑樹。紅黑樹是一種近似於平衡的二叉查找樹,裏面的數據是有序的。在紅黑樹上作查找操做的時間複雜度爲 O(logN)。而unordered_map對應 哈希表,哈希表的特色就是查找效率高,時間複雜度爲常數級別 O(1), 而額外空間複雜度則要高出許多。因此對於須要高效率查詢的狀況,使用unordered_map容器。而若是對內存大小比較敏感或者數據存儲要求有序的話,則能夠用map容器。 element

相關文章
相關標籤/搜索